// Code generated by gotdgen, DO NOT EDIT.

package tdapi

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// CanPurchasePremiumRequest represents TL type `canPurchasePremium#e9de1cc0`.
type CanPurchasePremiumRequest struct {
	// Transaction purpose
	Purpose StorePaymentPurposeClass
}

// CanPurchasePremiumRequestTypeID is TL type id of CanPurchasePremiumRequest.
const CanPurchasePremiumRequestTypeID = 0xe9de1cc0

// Ensuring interfaces in compile-time for CanPurchasePremiumRequest.
var (
	_ bin.Encoder     = &CanPurchasePremiumRequest{}
	_ bin.Decoder     = &CanPurchasePremiumRequest{}
	_ bin.BareEncoder = &CanPurchasePremiumRequest{}
	_ bin.BareDecoder = &CanPurchasePremiumRequest{}
)

func (c *CanPurchasePremiumRequest) Zero() bool {
	if c == nil {
		return true
	}
	if !(c.Purpose == nil) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (c *CanPurchasePremiumRequest) String() string {
	if c == nil {
		return "CanPurchasePremiumRequest(nil)"
	}
	type Alias CanPurchasePremiumRequest
	return fmt.Sprintf("CanPurchasePremiumRequest%+v", Alias(*c))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*CanPurchasePremiumRequest) TypeID() uint32 {
	return CanPurchasePremiumRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*CanPurchasePremiumRequest) TypeName() string {
	return "canPurchasePremium"
}

// TypeInfo returns info about TL type.
func (c *CanPurchasePremiumRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "canPurchasePremium",
		ID:   CanPurchasePremiumRequestTypeID,
	}
	if c == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "Purpose",
			SchemaName: "purpose",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (c *CanPurchasePremiumRequest) Encode(b *bin.Buffer) error {
	if c == nil {
		return fmt.Errorf("can't encode canPurchasePremium#e9de1cc0 as nil")
	}
	b.PutID(CanPurchasePremiumRequestTypeID)
	return c.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (c *CanPurchasePremiumRequest) EncodeBare(b *bin.Buffer) error {
	if c == nil {
		return fmt.Errorf("can't encode canPurchasePremium#e9de1cc0 as nil")
	}
	if c.Purpose == nil {
		return fmt.Errorf("unable to encode canPurchasePremium#e9de1cc0: field purpose is nil")
	}
	if err := c.Purpose.Encode(b); err != nil {
		return fmt.Errorf("unable to encode canPurchasePremium#e9de1cc0: field purpose: %w", err)
	}
	return nil
}

// Decode implements bin.Decoder.
func (c *CanPurchasePremiumRequest) Decode(b *bin.Buffer) error {
	if c == nil {
		return fmt.Errorf("can't decode canPurchasePremium#e9de1cc0 to nil")
	}
	if err := b.ConsumeID(CanPurchasePremiumRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode canPurchasePremium#e9de1cc0: %w", err)
	}
	return c.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (c *CanPurchasePremiumRequest) DecodeBare(b *bin.Buffer) error {
	if c == nil {
		return fmt.Errorf("can't decode canPurchasePremium#e9de1cc0 to nil")
	}
	{
		value, err := DecodeStorePaymentPurpose(b)
		if err != nil {
			return fmt.Errorf("unable to decode canPurchasePremium#e9de1cc0: field purpose: %w", err)
		}
		c.Purpose = value
	}
	return nil
}

// EncodeTDLibJSON implements tdjson.TDLibEncoder.
func (c *CanPurchasePremiumRequest) EncodeTDLibJSON(b tdjson.Encoder) error {
	if c == nil {
		return fmt.Errorf("can't encode canPurchasePremium#e9de1cc0 as nil")
	}
	b.ObjStart()
	b.PutID("canPurchasePremium")
	b.Comma()
	b.FieldStart("purpose")
	if c.Purpose == nil {
		return fmt.Errorf("unable to encode canPurchasePremium#e9de1cc0: field purpose is nil")
	}
	if err := c.Purpose.EncodeTDLibJSON(b); err != nil {
		return fmt.Errorf("unable to encode canPurchasePremium#e9de1cc0: field purpose: %w", err)
	}
	b.Comma()
	b.StripComma()
	b.ObjEnd()
	return nil
}

// DecodeTDLibJSON implements tdjson.TDLibDecoder.
func (c *CanPurchasePremiumRequest) DecodeTDLibJSON(b tdjson.Decoder) error {
	if c == nil {
		return fmt.Errorf("can't decode canPurchasePremium#e9de1cc0 to nil")
	}

	return b.Obj(func(b tdjson.Decoder, key []byte) error {
		switch string(key) {
		case tdjson.TypeField:
			if err := b.ConsumeID("canPurchasePremium"); err != nil {
				return fmt.Errorf("unable to decode canPurchasePremium#e9de1cc0: %w", err)
			}
		case "purpose":
			value, err := DecodeTDLibJSONStorePaymentPurpose(b)
			if err != nil {
				return fmt.Errorf("unable to decode canPurchasePremium#e9de1cc0: field purpose: %w", err)
			}
			c.Purpose = value
		default:
			return b.Skip()
		}
		return nil
	})
}

// GetPurpose returns value of Purpose field.
func (c *CanPurchasePremiumRequest) GetPurpose() (value StorePaymentPurposeClass) {
	if c == nil {
		return
	}
	return c.Purpose
}

// CanPurchasePremium invokes method canPurchasePremium#e9de1cc0 returning error if any.
func (c *Client) CanPurchasePremium(ctx context.Context, purpose StorePaymentPurposeClass) error {
	var ok Ok

	request := &CanPurchasePremiumRequest{
		Purpose: purpose,
	}
	if err := c.rpc.Invoke(ctx, request, &ok); err != nil {
		return err
	}
	return nil
}
