// Code generated by gotdgen, DO NOT EDIT.

package tdapi

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// ReadAllChatReactionsRequest represents TL type `readAllChatReactions#54c1976d`.
type ReadAllChatReactionsRequest struct {
	// Chat identifier
	ChatID int64
}

// ReadAllChatReactionsRequestTypeID is TL type id of ReadAllChatReactionsRequest.
const ReadAllChatReactionsRequestTypeID = 0x54c1976d

// Ensuring interfaces in compile-time for ReadAllChatReactionsRequest.
var (
	_ bin.Encoder     = &ReadAllChatReactionsRequest{}
	_ bin.Decoder     = &ReadAllChatReactionsRequest{}
	_ bin.BareEncoder = &ReadAllChatReactionsRequest{}
	_ bin.BareDecoder = &ReadAllChatReactionsRequest{}
)

func (r *ReadAllChatReactionsRequest) Zero() bool {
	if r == nil {
		return true
	}
	if !(r.ChatID == 0) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (r *ReadAllChatReactionsRequest) String() string {
	if r == nil {
		return "ReadAllChatReactionsRequest(nil)"
	}
	type Alias ReadAllChatReactionsRequest
	return fmt.Sprintf("ReadAllChatReactionsRequest%+v", Alias(*r))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*ReadAllChatReactionsRequest) TypeID() uint32 {
	return ReadAllChatReactionsRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*ReadAllChatReactionsRequest) TypeName() string {
	return "readAllChatReactions"
}

// TypeInfo returns info about TL type.
func (r *ReadAllChatReactionsRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "readAllChatReactions",
		ID:   ReadAllChatReactionsRequestTypeID,
	}
	if r == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "ChatID",
			SchemaName: "chat_id",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (r *ReadAllChatReactionsRequest) Encode(b *bin.Buffer) error {
	if r == nil {
		return fmt.Errorf("can't encode readAllChatReactions#54c1976d as nil")
	}
	b.PutID(ReadAllChatReactionsRequestTypeID)
	return r.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (r *ReadAllChatReactionsRequest) EncodeBare(b *bin.Buffer) error {
	if r == nil {
		return fmt.Errorf("can't encode readAllChatReactions#54c1976d as nil")
	}
	b.PutInt53(r.ChatID)
	return nil
}

// Decode implements bin.Decoder.
func (r *ReadAllChatReactionsRequest) Decode(b *bin.Buffer) error {
	if r == nil {
		return fmt.Errorf("can't decode readAllChatReactions#54c1976d to nil")
	}
	if err := b.ConsumeID(ReadAllChatReactionsRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode readAllChatReactions#54c1976d: %w", err)
	}
	return r.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (r *ReadAllChatReactionsRequest) DecodeBare(b *bin.Buffer) error {
	if r == nil {
		return fmt.Errorf("can't decode readAllChatReactions#54c1976d to nil")
	}
	{
		value, err := b.Int53()
		if err != nil {
			return fmt.Errorf("unable to decode readAllChatReactions#54c1976d: field chat_id: %w", err)
		}
		r.ChatID = value
	}
	return nil
}

// EncodeTDLibJSON implements tdjson.TDLibEncoder.
func (r *ReadAllChatReactionsRequest) EncodeTDLibJSON(b tdjson.Encoder) error {
	if r == nil {
		return fmt.Errorf("can't encode readAllChatReactions#54c1976d as nil")
	}
	b.ObjStart()
	b.PutID("readAllChatReactions")
	b.Comma()
	b.FieldStart("chat_id")
	b.PutInt53(r.ChatID)
	b.Comma()
	b.StripComma()
	b.ObjEnd()
	return nil
}

// DecodeTDLibJSON implements tdjson.TDLibDecoder.
func (r *ReadAllChatReactionsRequest) DecodeTDLibJSON(b tdjson.Decoder) error {
	if r == nil {
		return fmt.Errorf("can't decode readAllChatReactions#54c1976d to nil")
	}

	return b.Obj(func(b tdjson.Decoder, key []byte) error {
		switch string(key) {
		case tdjson.TypeField:
			if err := b.ConsumeID("readAllChatReactions"); err != nil {
				return fmt.Errorf("unable to decode readAllChatReactions#54c1976d: %w", err)
			}
		case "chat_id":
			value, err := b.Int53()
			if err != nil {
				return fmt.Errorf("unable to decode readAllChatReactions#54c1976d: field chat_id: %w", err)
			}
			r.ChatID = value
		default:
			return b.Skip()
		}
		return nil
	})
}

// GetChatID returns value of ChatID field.
func (r *ReadAllChatReactionsRequest) GetChatID() (value int64) {
	if r == nil {
		return
	}
	return r.ChatID
}

// ReadAllChatReactions invokes method readAllChatReactions#54c1976d returning error if any.
func (c *Client) ReadAllChatReactions(ctx context.Context, chatid int64) error {
	var ok Ok

	request := &ReadAllChatReactionsRequest{
		ChatID: chatid,
	}
	if err := c.rpc.Invoke(ctx, request, &ok); err != nil {
		return err
	}
	return nil
}
